# HBuilder X - Release Notes
======================================
## 3.6.2.20220914
* Added UTS syntax support. Develop native using TypeScript [Details](https://en.uniapp.dcloud.io/tutorial/syntax-uts.html)
* Added the function of finding references, currently only supports js and ts
* Windows: Upgrade built-in browser, Upgrade Cef version to 90.6.7
* HBuilderX settings, plugin configuration, add configuration items, Enable JavaScript Validation, Enable TypeScript Validation
* Language Server: Added real-time verification of variable syntax in vue and js (js verification needs to be enabled in [Settings - Plugin Configuration])
* Language Server: Added built-in syntax check to support warning level
* Language Server: Added vue3 `style module` to support code hints
* Language Server: Added vue2&3 `slot` to support code hints
* Language Server: Added vue2&3 script area to support automatic package import
* Language Server: Fixed the bug that vuedoc does not take effect in script setup
* Language Server: Fixed The custom component of vue3 `script setup` import, the bug that cannot be prompted in the template area
* Language Server: Fixed the bug that `()` will be repeatedly generated when modifying the name of the function call
* Language Server: Fixed the bug that special String does not support `if(idstr === '|')`
* Language Server: Fixed the bug that the variable suspension in the vue template area does not take effect
* Language Server: Fixed `uniCloud.importObject()`, after the cloud object is modified, the code prompt and suspension cannot take effect in real time
* Language Server: Optimized `uniCloud.importObject()`, code hints for parameters and return values ​​when calling methods on cloud objects
* Language Server: Fixed the bug that the framework package of the vetur specification could not take effect in real time when it was installed and uninstalled
* Language Server: Fixed the bug that the suspension of variables and functions referencing other files in the html script did not take effect
* Language Server: Fixed the bug that the return value and parameter type are incorrect when parsing the function that references other files in the html script
* Language Server: Fixed the bug that the frame syntax library of the status bar at the bottom of HBuilderX did not take effect when removed
* Language Server: Fixed the vue-cli project, the script area in vue will not recognize the bug of tsconfig.json under the project
* Language Server: Optimization After setting `px` to `rem`, the conversion prompt is placed in the first item of the code prompt
* Language Server: Fixed JavaScript `Object.` does not prompt the bug of es6+ new methods
* Language Server: Fixed `import xxx from 'XXX.vue'` without the vue suffix, prompting that the module cannot be found, and cannot go to the defined bug
* Language Server: Fixed the bug that the code prompt could not be automatically triggered when typing the character `.` in jsx and tsx files
* Fixed Editor, Close Tab, in some cases, the bug of not remembering the folded state
* Added tabs Right-click menu Add menus Move tabs to the left, move tabs to the right
* Windows: Fixed the bug that when HBuilderX is not started, when importing the plugin market plugin, the UI view of the first import shows a blank bug
* Fixed the bug that the jump position is wrong in some cases of multi-file character search
* Fixed the bug that when going back to another file, the cursor jumps to the beginning of the file instead of going to the position before the definition
* Added new project, HBuilderX plugin, added internationalization example template
* Fixed the bug that debug view, variable, Global node, UI display disorder
* Fixed the bug that HBuilderX saves files in utf-8 format without file header identification byte 0xEFBBBF
* Mobile App - Cloud packaging: Fixed the bug that when the static resource file under the project is too large (over 100M), the packaged bug cannot be submitted
* Mobile App - Cloud packaging: Fixed the bug that HBuilderX crashed when submitting packaging in some cases on Windows
* Mobile App Playground, using Node to run, no longer relying on Java
* Added Mobile App Playground, Device selection window, added base selection function
* Fixed Mobile App Playground, When the project path exists in Chinese and runs to an iOS device, the App page displays an abnormal bug
* Fixed Mobile App Playground, a bug where custom base installation failed in some cases
* uni-app: Build, H5 and Mini-Programe, window UI text internationalization
* uni-app：Fixed manifest.json, a bug that the uniPush field becomes null in some cases
* uni-app: Fixed manifest.json After the application name is internationalized, the packaging interface, the application name displays `%%`
* uni-app: Adjust the H5 configuration on the left side of manifest.json to the Web configuration
* [uni-app plugin]
  + [Important] Added uts Android plugin [Details](https://uniapp.dcloud.net.cn/plugin/uts-plugin.html)
  + Fixed Compile exception when project path contains parentheses. [Details](https://ask.dcloud.net.cn/question/150173)
  + App Updated The web-view for Vue2 project can use webviewStyles set more style. [Details](https://ask.dcloud.net.cn/question/149212)
  + App Updated The web-view for Vue page can drawn outside of safe area by default. [Details](https://ask.dcloud.net.cn/question/149472)
  + App Fixed Vue page cover-view component flex layout is invalid. [Details](https://ask.dcloud.net.cn/question/151697)
  + App Fixed Vue3 project uni.getSystemInfo gets windowHeight value is inaccurate. [Details](https://ask.dcloud.net.cn/question/150862)
  + App Fixed Vue3 project vue page map component shows error after updating center coordinates. [Details](https://ask.dcloud.net.cn/question/151438)
  + App-Android Fixed the bug that the overlapping coordinates of the nvue map marker points cannot be displayed [Details](https://ask.dcloud.net.cn/question/149665)
  + App-Android Fixed the bug that the nvue map component does not take effect when the polyline and polygon data are cleared
  + App-Android Fixed uni.saveImageToPhotosAlbum saving network pictures may overwrite the last saved picture. [Details](https://ask.dcloud.net.cn/question/125357)
  + App-Android Fixed Picker component focus acquisition exception. [Details](https://ask.dcloud.net.cn/question/150454)
  + App-Android Fixed Nvue page map component customCallout setting image may cause application crash. [Details](https://ask.dcloud.net.cn/question/150166)
  + App-Android Fixed bindingx may cause exceptions when executing evaluatecolor [Details](https://ask.dcloud.net.cn/question/151759) 
  + App-Android Fixed uni.reLaunch opens non-tabbar nvue pages may still show tabbar [Details](https://ask.dcloud.net.cn/question/143792)
  + App-Android Fixed AutoNavi Maps not working properly when setting GooglePlay channel [Details](https://ask.dcloud.net.cn/question/152668)
  + App-Android Fixed using the picker in nvue as homepage may cause the app to become unresponsive [Details](https://ask.dcloud.net.cn/question/151819)
  + App-iOS Fixed the bug that uni.setTabBarItem dynamic update icon may not take effect [Details](https://ask.dcloud.net.cn/question/149955)
  + App-iOS Fixed the bug that the nvue map component may not be loaded properly in multiple pages when use Google map moudle [Details](https://ask.dcloud.net.cn/question/150080)
  + App-iOS Fixed The values of bluetoothEnabled and locationEnabled obtained by uni.getSystemSetting are inaccurate.
  + App-iOS Fixed The nvue page map component marker calls the moveAlong method without interrupting the previous animation. [Details](https://ask.dcloud.net.cn/question/151411)
  + App-iOS Fixed The nvue page ad-content-page component may cause the app to crash in some scenarios. [Details](https://ask.dcloud.net.cn/question/151778)
  + App-iOS Fixed uni.openLocation bottom safe area adaptation problem [Details](https://ask.dcloud.net.cn/question/150074)
  + App-iOS Fixed That uni.chooseLocation may cause the app to crash [Details](https://ask.dcloud.net.cn/question/152367)
  + App-iOS Fixed Nvue Tabbar page uni.reLaunch could not triggered onUnload lifetimes [Details](https://ask.dcloud.net.cn/question/152738)
  + Web Added Support for configuring and using AutoNavi maps [Details](https://uniapp.dcloud.io/collocation/manifest?id=h5sdkconfigmaps)
  + Web Updated The web-view component support props of fullscreen. [Details](https://uniapp.dcloud.net.cn/component/web-view.html)
  + Web Fixed The touch envet stop and prevent for canvas component are invalid. [Details](https://ask.dcloud.net.cn/question/148195)
  + Web Fixed Vue3 project css environment variable --window-top calculation error. [Details](https://ask.dcloud.net.cn/question/150842)
  + Web Fixed Vue3 project release mode showLoading icon size display error. [Details](https://ask.dcloud.net.cn/question/149819)
  + Web Fixed custom-tab-bar component using uni.setTabBarItem to set visible is invalid. [Details](https://ask.dcloud.net.cn/question/132947)
  + Web Fixed Calling uni.setClipboardData will bring up the keyboard [Details](https://github.com/dcloudio/uni-app/issues/3569)
  + Mini Program Fixed v-model fails after complex expressions are used in v-for. [Details](https://github.com/dcloudio/uni-app/issues/3173)
  + Mini Program Fixed Updated The Mini Program component supports the use of kebab-case event names [Details](https://github.com/dcloudio/uni-app/issues/1802)
  + Alipay Mini Program, Baidu Mini Program, Kuaishou Mini Program, ByteDance Mini Program Updated Support automatic copying of ext.json files.  
  + Weixin Mini Program Fixed Calling triggerEvent in wxs cannot carry event parameters [Details](https://github.com/dcloudio/uni-app/issues/3829)
  + Alipay Mini Program Updated The uni.saveImageToPhotosAlbum interface no longer uses the legacy saveImage interface.
  + Alipay Mini Program Fixed Compiling error after configuring global Mini Program components [Details](https://github.com/dcloudio/uni-app/issues/3619)
  + Alipay Mini Program Fixed Accessing $slots after enabling Mini Program Basic Library 2.0 configuration [Details](https://github.com/dcloudio/uni-app/issues/3529)
  + ByteDance Mini Program Added vue2 project to support onUploadDouyinVideo lifetimes [Details](https://ask.dcloud.net.cn/question/151113)
  + ByteDance Mini Program Fixed Component fails to render when repeatedly creating and destroying pages quickly.
* [uniCloud plugin]
  + Updated UniCloud HBuilderX plugin, Change parameter of running cloud object by HBuilderX [Details](https://uniapp.dcloud.net.cn/uniCloud/rundebug.html#run-obj-param)
  + Updated Aliyun Extend the timeout of database request from 3s to 5s
  + Added Aliyun Implement eip with http proxy provided by aliyun [Details](https://uniapp.dcloud.net.cn/uniCloud/cf-functions.html#http-proxy-client)
  + Added CloudFunction Add context.requestId to get current request id in cloudfunction [Details](https://uniapp.dcloud.net.cn/uniCloud/cf-functions.html#context)
  + Added CloudObject Add this.getUniCloudRequestId() to get current request id in cloudobject [Details](https://uniapp.dcloud.net.cn/uniCloud/cloud-obj.html#get-request-id)
  + Added CloudSdk Add uniCloud.getRequestList to get the list of request id being processed by current cloudfunction instance [Details](https://uniapp.dcloud.net.cn/uniCloud/cf-functions.html#get-request-list)
  + Added CloudSdk Add uniCloud.getCloudInfos to get the list of cloud info being processed by current cloudfunction instance [Details](https://uniapp.dcloud.net.cn/uniCloud/cf-functions.html#get-cloud-infos)
  + Added CloudSdk Add uniCloud.getClientInfos to get the list of client info being processed by current cloudfunction instance [Details](https://uniapp.dcloud.net.cn/uniCloud/cf-functions.html#get-cloud-infos)
  + Fixed ClientSdk Using uniCloud object cause error when uniCloud space was not bound to project [Details](https://github.com/dcloudio/uni-app/issues/3758)
  + Fixed JQL Multi parentKey in schema is unable to query with getTree [Details](https://ask.dcloud.net.cn/question/151834)
  + Fixed UniCloudDebugger Extension is not loaded properly in some situation [Details](https://ask.dcloud.net.cn/question/150357)
  + Fixed UniCloudDebugger Memory leak of dev server which cause slow responding
  + Updated uniIdRouter It's able to intercept home page or launch page loading now
  + Updated uni-id-co Password rule updated, password strength is configurable. [Details](https://uniapp.dcloud.net.cn/uniCloud/uni-id-summary.html#password-strength)
  + Updated uni-id-co Save user openid into `wx_openid.${mp|h5|app|web}` and `wx_openid.${mp|h5|app|web}_${DCloudAppId}` of user record [Login by weixin](https://uniapp.dcloud.net.cn/uniCloud/uni-id-pages.html#login-by-weixin)、[Login by QQ](https://uniapp.dcloud.net.cn/uniCloud/uni-id-pages.html#login-by-qq)
  + Updated uni-id-co Save user session_key, access_token with uni-open-bridge-common [Details](https://uniapp.dcloud.net.cn/uniCloud/uni-id-summary.html#save-user-token)
  + Added uni-id-co Add beforeRegister hook to manipulate user record before register [Details](https://uniapp.dcloud.net.cn/uniCloud/uni-id-summary.html#before-register)
  + Added uni-id-pages Support login by weixin official account web page and wechat's qrcode of web page [Details](https://uniapp.dcloud.net.cn/uniCloud/uni-id-pages.html#weixinlogin)
  + Added uni-id-pages Support password strength (whether it must contain upper and lower case letters, numbers, special symbols and length) configuration [Details](https://uniapp.dcloud.net.cn/uniCloud/uni-id-pages.html#config)
  + Added uni-id-pages Add global login success event: `uni-id-pages-login-success`, listen this event by [uni.$on](https://uniapp.dcloud.net.cn/api/window/communication.html#on)
  + Added IP anti-brushing for cloudfunction and clientDB [Details](https://uniapp.dcloud.net.cn/uniCloud/ip-filter.html)
  + Fixed use uniCloud inside main.js cause error in some situation
  + Fixed uni-admin vue3 The value of showLeftWindow is incorrect after uni.showLeftWindow was called [Details](https://ask.dcloud.net.cn/question/149618)
  + Added uni-statistics2 Add config item to set the duration of periodic reporting of data [Details](https://uniapp.dcloud.net.cn/uni-stat-v2.html#report-time)

## 3.5.3.20220729
* Added HBuilderX status bar Upgrade added red dot prompt
* Added MarkDown code block to support language coloring and highlighting, you need to download and add the corresponding language coloring extension plug-in
* Added Markdown support to go to `#title` or `@`alias of title across files
* Added TypeScript support for syntax verification
* Added language service to support tailwindcss, need to install tailwindcss plugin [Details](https://ext.dcloud.net.cn/plugin?id=8560)
* Fixed language service React, add `()` bug after `<App />` carriage return
* Fixed language service React jsx file no code hint bug
* Fixed language service CSS pointer-events missing auto attribute bug
* Fixed the bug of code block settings, custom other language code blocks, two JSON options appear in the window list
* Fixed the bug that the `$DATE_TIME` in the comment of the custom code block displays the wrong date
* Fixed the operating system environment variable, configuring `NODE_OPTIONS --openssl-legacy-provider`, HBuilderX loses response when it starts
* Fixed the bug that the plugin API `hx.window.showQuickPick()` window could not scroll after opening the terminal
* Fixed the bug that the cursor position is wrong after opening the document for the first time and editing it for the first time
* Fixed the bug that the editor selects the language association window position offset
* Fixed the bug of plugin installation try move failed in some cases
* Git plugin, pull operation, the default option is changed to the fourth item, namely `git pull --rebase --autostash`
* Fixed some issues for language service

## 3.4.18.20220630
* Fixed the bug that json file search index symbol causes crash.
* Fixed the bug that the closed tag does not have a dotted box after the html tag is selected.
* Fixed the bug that the hover list disappears automatically when Windows opens the terminal, searches for categories in the toolbar, and moves the mouse to it.

## 3.4.15.20220610
* Fixed PHP files, comment shortcuts, comment bugs

## 3.4.14.20220607
* Added HBuilderX Support for custom project Snippets
* Added support for running and debugging Node programs
* Some of the built-in language syntax highlighting was migrated to the plug-in marketplace
* Added syntax highlighting that can be independently extended for new languages, and language highlighting plug-ins can be developed or downloaded
* Added language service, JavaScript supports DOM type recognition of id selectors in Document. getElementById and Document. querySelector
* Added language service, SCSS support for prompt `!global` and `!default`
* Added language service, VUE-CLI projects, code hints support element-UI, bootstrap-vue, etc
* Fixed language service, input CSS code in the same line, press Enter, replace the wrong position Bug
* Fixed language service, jsdoc carriage return error Bug
* Fixed Emmet syntax bug where pressing TAB did not respond correctly
* Fixed multi-file search, the right side of the display code coloring error Bug
* Fixed plug-in installation window, installed plug-in, version number display error Bug

## 3.4.7.20220422
* Fixed some issues for language service

## 3.4.6.20220420
* HBuilderX language service switched from Java to Node
* Fixed a bug where files in the editor would not be automatically refreshed after Git updated files in some cases
* Adjust Share to Weblink, adjust code area code coloring

## 3.3.13.20220314
* Fixed some minor issues

## 3.3.11.20220210
* Fixed some minor issues

## 3.3.10.20220124
* Fixed some minor issues

## 3.3.9.20220121
* Fixed the bug that the project manager project cannot be expanded in some cases on MacOSX

## 3.3.5.20211229
* Fixed some minor issues

## 3.3.4.20211228
* Fixed some minor issues

## 3.3.3.20211225
* Adjust the UI of the new project window [Details](https://hx.dcloud.net.cn/Tutorial/project?id=CreateProjectWindows)
* Added project manager view toolbar, added positioning and folding functions [Details](https://hx.dcloud.net.cn/Tutorial/project?id=toolbar)
* Fixed a crash in the editor when Find Symbols by clicking on the search area or the built-in Explorer address bar.
* Fixed the Bug where MacOSX failed to run projects to iOS emulator when the HBuilderX installation path had a space.

## 3.2.16.20211122
* Fixed the bug that the hover code assist the editor to crash

## 3.2.15.20211120
* Added Files larger than 1M in size do not display hover code assist
* Fixed the bug that caused the node process to fail to start when the max-old-space-size configured in the operating system environment variables was too large

## 3.2.12.20211029
* Added HBuilderX plug-in development breakpoint debugging
* Added hover code assist [Details](https://hx.dcloud.net.cn/Tutorial/Language/Overview?id=hover-code-assist)
* Added Terminal supports clicking on the URL to jump to the browser [Details](https://hx.dcloud.net.cn/Tutorial/UserGuide/terminal?id=open-links)
* Fixed the bug that when the terminal input exceeds a certain length, the wrong line is displayed
* Fixed the bug that the editor window exceeds the screen area when creating multiple terminals
* Fixed the bug that the editor bookmarks are lost due to code formatting

## 3.2.9.20210927
* Added HBuilderX supports localized language pack extension [Details](https://github.com/dcloudio/hbuilderx-language-packs)
* Vue3 improvements [Details](https://hx.dcloud.net.cn/Tutorial/Language/vue-next)
* Added Configure whether you receive automatic updates.